	;
	; String input routine
	;
	; Let's the user input (type, edit) any string.
	;
StringInput
	jsr DisplayString
	;
si_main	lda #InputKeys & 255
	ldx #InputKeys >> 8
	jmp keyboard 

si_Return			; When Return/Enter is pressed, simply return (since all of this is a JSR call)
	rts
	;
	; --- Typed one character
	;	
si_type
	ldy si_curpos		; check cursor position
	cpy si_maxlen		; to max size: are we at the end?
	beq si_main		; yes, buffer full, exit
	;
	jsr si_insert
	;
	lda keyb_shift		; was shift pressed?
	beq si07
	;
	txa
	clc
	adc #TypedChars_End - TypedChars
	tax
	;
si07	lda TypedChars,x	; load keycode for pressed key
	sta si_string,y		; store the type character
	;
	inc si_curpos		; cursor goes forward
	;
	jmp StringInput		; Update display and continue loop
	;
	; --- Cursor right
	;	
si_Right
	ldx si_curpos		; are we already at the end?
	cpx si_maxlen
	beq si_ret
	;
	inx			; cursor goes right
	bne si10		; always jump
	;
	; --- Cursor left
	;
si_Left
	ldx si_curpos		; are we already at the beginning?
	beq si_ret
	;
	dex			; cursor goes left
si10	stx si_curpos
	;
	jmp StringInput		; Update display and continue loop
	;
si_ret	jmp si_main		; Continue loop
	;
	; --- Insert/Delete
	;	
si_Del
	lda keyb_shift		; check shift to determine if it's INST or DEL
	beq si13
	;
	ldy si_curpos		; check cursor position
	cpy si_maxlen		; to max size: are we at the end?
	beq si_ret
	;
	jsr si_insert		; inst!
	;
	lda #si_space
	sta si_string,y		; add a space
	;
	jmp StringInput		; Update display and continue loop
	;
si13	ldx si_curpos		; cursor at beginning?
	beq si_ret
	bne si12
	;
si11	lda si_string,x
	sta si_string-1,x
	inx
si12	cpx si_maxlen
	bne si11
	;
	lda #si_space
	sta si_string-1,x
	;
	dec si_curpos
	;
	jmp StringInput		; Update display and continue loop
	;
	; --- Clear/Home
	;	
si_Home
	lda #$00
	sta si_curpos
	;
	lda keyb_shift
	beq si_h1
	;
	jsr StringInputClear 
	;
si_h1	jmp StringInput		; Update display and continue loop
	;
	; "Insert" one character at cursor position
	; return: y = current cursor position
	;
si_insert
	ldy si_maxlen		; copy next chars forward
	dey
	jmp si06
si05	dey
	lda si_string,y
	sta si_string+1,y
si06	cpy si_curpos
	bne si05
	;
	rts
	;
	; Clear the input string buffer
	;
StringInputClear
	ldx #$00
	stx si_curpos
	;
	lda #si_space
sic	sta si_string,x
	inx
	cpx si_maxlen
	bne sic
	;
	rts  
	
	;
	; The following keys can be typed.
	; Additional keys (e.g. numbers, etc) can be added.
	;
	cmap
	cmap "a",1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26
TypedChars
	db " abcdefghijklmnopqrstuvwxyz.-/"	; typed without shift
TypedChars_End
	db " ABCDEFGHIJKLMNOPQRSTUVWXYZ.-/"	; typed with shift
	
InputKeys
	dw si_Return
	;
	dw KEY_SPACE, si_type
	dw KEY_A, si_type
	dw KEY_B, si_type
	dw KEY_C, si_type
	dw KEY_D, si_type
	dw KEY_E, si_type
	dw KEY_F, si_type
	dw KEY_G, si_type
	dw KEY_H, si_type
	dw KEY_I, si_type
	dw KEY_J, si_type
	dw KEY_K, si_type
	dw KEY_L, si_type
	dw KEY_M, si_type
	dw KEY_N, si_type
	dw KEY_O, si_type
	dw KEY_P, si_type
	dw KEY_Q, si_type
	dw KEY_R, si_type
	dw KEY_S, si_type
	dw KEY_T, si_type
	dw KEY_U, si_type
	dw KEY_V, si_type
	dw KEY_W, si_type
	dw KEY_X, si_type
	dw KEY_Y, si_type
	dw KEY_Z, si_type
	dw KEY_DOT, si_type
	dw KEY_MINUS, si_type
	dw KEY_SLASH, si_type
	;
	dw KEY_CURSOR_RIGHT, si_Right
	dw KEY_CURSOR_LEFT, si_Left
	dw KEY_INST_DEL, si_Del
	dw KEY_CLEAR_HOME, si_Home
	dw KEY_RETURN, si_Return
	db 0
;[eof]